diff --git a/src/screen.c b/src/screen.c
index 33cb3cc..12ac091 100644
--- a/src/screen.c
+++ b/src/screen.c
@@ -184,6 +184,9 @@ setDesktopHints (CompScreen *s)
     unsigned long *data;
     int		  size, offset, hintSize, i;
 
+    if (!s->root.substructureRedirect)
+	return;
+
     size = s->nDesktop * 2 + s->nDesktop * 2 + s->nDesktop * 4 + 1;
 
     data = malloc (sizeof (unsigned long) * size);
@@ -200,7 +203,7 @@ setDesktopHints (CompScreen *s)
     }
 
     if (!desktopHintEqual (s, data, size, offset, hintSize))
-	XChangeProperty (d->display, s->root, d->desktopViewportAtom,
+	XChangeProperty (d->display, s->root.id, d->desktopViewportAtom,
 			 XA_CARDINAL, 32, PropModeReplace,
 			 (unsigned char *) &data[offset], hintSize);
 
@@ -213,7 +216,7 @@ setDesktopHints (CompScreen *s)
     }
 
     if (!desktopHintEqual (s, data, size, offset, hintSize))
-	XChangeProperty (d->display, s->root, d->desktopGeometryAtom,
+	XChangeProperty (d->display, s->root.id, d->desktopGeometryAtom,
 			 XA_CARDINAL, 32, PropModeReplace,
 			 (unsigned char *) &data[offset], hintSize);
 
@@ -229,7 +232,7 @@ setDesktopHints (CompScreen *s)
     }
 
     if (!desktopHintEqual (s, data, size, offset, hintSize))
-	XChangeProperty (d->display, s->root, d->workareaAtom,
+	XChangeProperty (d->display, s->root.id, d->workareaAtom,
 			 XA_CARDINAL, 32, PropModeReplace,
 			 (unsigned char *) &data[offset], hintSize);
 
@@ -239,7 +242,7 @@ setDesktopHints (CompScreen *s)
     hintSize = 1;
 
     if (!desktopHintEqual (s, data, size, offset, hintSize))
-	XChangeProperty (d->display, s->root, d->numberOfDesktopsAtom,
+	XChangeProperty (d->display, s->root.id, d->numberOfDesktopsAtom,
 			 XA_CARDINAL, 32, PropModeReplace,
 			 (unsigned char *) &data[offset], hintSize);
 
@@ -375,8 +378,11 @@ updateOutputDevices (CompScreen	*s)
 
     updateWorkareaForScreen (s);
 
-    setDefaultViewport (s);
-    damageScreen (s);
+    if (manualCompositeManagement)
+    {
+	setDefaultViewport (s);
+	damageScreen (s);
+    }
 
     region = XCreateRegion ();
     if (region)
@@ -644,9 +650,9 @@ static void
 updateStartupFeedback (CompScreen *s)
 {
     if (s->startupSequences)
-	XDefineCursor (s->display->display, s->root, s->busyCursor);
+	XDefineCursor (s->display->display, s->root.id, s->busyCursor);
     else
-	XDefineCursor (s->display->display, s->root, s->normalCursor);
+	XDefineCursor (s->display->display, s->root.id, s->normalCursor);
 }
 
 #define STARTUP_TIMEOUT_DELAY 15000
@@ -853,11 +859,12 @@ reshape (CompScreen *s,
 {
 
 #ifdef USE_COW
-    if (useCow)
+    if (useCow && manualCompositeManagement)
 	XMoveResizeWindow (s->display->display, s->overlay, 0, 0, w, h);
 #endif
 
-    if (s->display->xineramaExtension)
+    if (s->display->xineramaExtension &&
+	XineramaIsActive (s->display->display))
     {
 	CompDisplay *d = s->display;
 
@@ -971,7 +978,7 @@ updateScreenBackground (CompScreen  *screen,
 
     for (i = 0; pixmap == 0 && i < 2; i++)
     {
-	status = XGetWindowProperty (dpy, screen->root,
+	status = XGetWindowProperty (dpy, screen->root.id,
 				     screen->display->xBackgroundAtom[i],
 				     0, 4, FALSE, AnyPropertyType,
 				     &actualType, &actualFormat, &nItems,
@@ -1054,7 +1061,7 @@ detectRefreshRateOfScreen (CompScreen *s)
 	{
 	    XRRScreenConfiguration *config;
 
-	    config  = XRRGetScreenInfo (s->display->display, s->root);
+	    config  = XRRGetScreenInfo (s->display->display, s->root.id);
 	    value.i = (int) XRRConfigCurrentRate (config);
 
 	    XRRFreeScreenConfigInfo (config);
@@ -1081,6 +1088,8 @@ setSupportingWmCheck (CompScreen *s)
 {
     CompDisplay *d = s->display;
 
+    s->root.supportingWmCheckWindow = s->grabWindow;
+
     XChangeProperty (d->display, s->grabWindow, d->supportingWmCheckAtom,
 		     XA_WINDOW, 32, PropModeReplace,
 		     (unsigned char *) &s->grabWindow, 1);
@@ -1098,7 +1107,7 @@ setSupportingWmCheck (CompScreen *s)
 		     XA_ATOM, 32, PropModeAppend,
 		     (unsigned char *) &d->winStateHiddenAtom, 1);
 
-    XChangeProperty (d->display, s->root, d->supportingWmCheckAtom,
+    XChangeProperty (d->display, s->root.id, d->supportingWmCheckAtom,
 		     XA_WINDOW, 32, PropModeReplace,
 		     (unsigned char *) &s->grabWindow, 1);
 }
@@ -1199,11 +1208,66 @@ setSupported (CompScreen *s)
     data[i++] = d->moveResizeWindowAtom;
     data[i++] = d->restackWindowAtom;
 
-    XChangeProperty (d->display, s->root, d->supportedAtom, XA_ATOM, 32,
+    data[i++] = d->syncStateAtom;
+
+    XChangeProperty (d->display, s->root.id, d->supportedAtom, XA_ATOM, 32,
 		     PropModeReplace, (unsigned char *) data, i);
 }
 
-static void
+void
+getSupportingWmCheck (CompWindow *w)
+{
+    CompDisplay   *d = w->screen->display;
+    Atom	  actual;
+    int		  result, format;
+    unsigned long n, left;
+    unsigned char *propData;
+
+    w->supportingWmCheckWindow = None;
+    w->syncStateSupport        = FALSE;
+
+    result = XGetWindowProperty (d->display, w->id,
+				 d->supportingWmCheckAtom, 0L, 1L, FALSE,
+				 XA_WINDOW, &actual, &format,
+				 &n, &left, &propData);
+    if (result == Success && n && propData)
+    {
+	Window wmCheckWindow = *((unsigned long *) propData);
+
+	XFree (propData);
+
+	result = XGetWindowProperty (d->display,
+				     wmCheckWindow,
+				     d->supportingWmCheckAtom, 0L, 1L, FALSE,
+				     XA_WINDOW, &actual, &format,
+				     &n, &left, &propData);
+	if (result == Success && n && propData)
+	{
+	    XFree (propData);
+
+	    w->supportingWmCheckWindow = wmCheckWindow;
+
+	    result = XGetWindowProperty (d->display,
+					 w->id,
+					 d->supportedAtom, 0L, 4096L,
+					 FALSE, XA_ATOM, &actual, &format,
+					 &n, &left, &propData);
+	    if (result == Success && n && propData)
+	    {
+		unsigned long *data = (unsigned long *) propData;
+		int           i;
+
+		for (i = 0; i < n; i++)
+		    if ((Atom) data[i] == d->syncStateAtom)
+			w->syncStateSupport = TRUE;
+
+		XFree (propData);
+	    }
+	}
+    }
+}
+
+void
 getDesktopHints (CompScreen *s)
 {
     CompDisplay   *d = s->display;
@@ -1215,7 +1279,7 @@ getDesktopHints (CompScreen *s)
 
     if (useDesktopHints)
     {
-	result = XGetWindowProperty (s->display->display, s->root,
+	result = XGetWindowProperty (s->display->display, s->root.id,
 				     d->numberOfDesktopsAtom, 0L, 1L, FALSE,
 				     XA_CARDINAL, &actual, &format,
 				     &n, &left, &propData);
@@ -1229,7 +1293,7 @@ getDesktopHints (CompScreen *s)
 		s->nDesktop = data[0];
 	}
 
-	result = XGetWindowProperty (s->display->display, s->root,
+	result = XGetWindowProperty (s->display->display, s->root.id,
 				     d->currentDesktopAtom, 0L, 1L, FALSE,
 				     XA_CARDINAL, &actual, &format,
 				     &n, &left, &propData);
@@ -1244,7 +1308,7 @@ getDesktopHints (CompScreen *s)
 	}
     }
 
-    result = XGetWindowProperty (s->display->display, s->root,
+    result = XGetWindowProperty (s->display->display, s->root.id,
 				 d->desktopViewportAtom, 0L, 2L,
 				 FALSE, XA_CARDINAL, &actual, &format,
 				 &n, &left, &propData);
@@ -1265,7 +1329,7 @@ getDesktopHints (CompScreen *s)
 	XFree (propData);
     }
 
-    result = XGetWindowProperty (s->display->display, s->root,
+    result = XGetWindowProperty (s->display->display, s->root.id,
 				 d->showingDesktopAtom, 0L, 1L, FALSE,
 				 XA_CARDINAL, &actual, &format,
 				 &n, &left, &propData);
@@ -1279,17 +1343,20 @@ getDesktopHints (CompScreen *s)
 	    (*s->enterShowDesktopMode) (s);
     }
 
-    data[0] = s->currentDesktop;
+    if (s->root.substructureRedirect)
+    {
+	data[0] = s->currentDesktop;
 
-    XChangeProperty (d->display, s->root, d->currentDesktopAtom,
-		     XA_CARDINAL, 32, PropModeReplace,
-		     (unsigned char *) data, 1);
+	XChangeProperty (d->display, s->root.id, d->currentDesktopAtom,
+			 XA_CARDINAL, 32, PropModeReplace,
+			 (unsigned char *) data, 1);
 
-    data[0] = s->showingDesktopMask ? TRUE : FALSE;
+	data[0] = s->showingDesktopMask ? TRUE : FALSE;
 
-    XChangeProperty (d->display, s->root, d->showingDesktopAtom,
-		     XA_CARDINAL, 32, PropModeReplace,
-		     (unsigned char *) data, 1);
+	XChangeProperty (d->display, s->root.id, d->showingDesktopAtom,
+			 XA_CARDINAL, 32, PropModeReplace,
+			 (unsigned char *) data, 1);
+    }
 }
 
 void
@@ -1297,7 +1364,7 @@ showOutputWindow (CompScreen *s)
 {
 
 #ifdef USE_COW
-    if (useCow)
+    if (useCow && manualCompositeManagement)
     {
 	Display       *dpy = s->display->display;
 	XserverRegion region;
@@ -1326,7 +1393,7 @@ hideOutputWindow (CompScreen *s)
 {
 
 #ifdef USE_COW
-    if (useCow)
+    if (useCow && manualCompositeManagement)
     {
 	Display       *dpy = s->display->display;
 	XserverRegion region;
@@ -1349,7 +1416,7 @@ updateOutputWindow (CompScreen *s)
 {
 
 #ifdef USE_COW
-    if (useCow)
+    if (useCow && manualCompositeManagement)
     {
 	Display       *dpy = s->display->display;
 	XserverRegion region;
@@ -1365,7 +1432,7 @@ updateOutputWindow (CompScreen *s)
 
 	XSubtractRegion (&s->region, &emptyRegion, tmpRegion);
 
-	for (w = s->reverseWindows; w; w = w->prev)
+	for (w = s->root.reverseWindows; w; w = w->prev)
 	    if (w->overlayWindow)
 	    {
 		XSubtractRegion (tmpRegion, w->region, tmpRegion);
@@ -1393,9 +1460,10 @@ makeOutputWindow (CompScreen *s)
 {
 
 #ifdef USE_COW
-    if (useCow)
+    if (useCow && manualCompositeManagement)
     {
-	s->overlay = XCompositeGetOverlayWindow (s->display->display, s->root);
+	s->overlay = XCompositeGetOverlayWindow (s->display->display,
+						 s->root.id);
 	s->output  = s->overlay;
 
 	XSelectInput (s->display->display, s->output, ExposureMask);
@@ -1403,7 +1471,7 @@ makeOutputWindow (CompScreen *s)
     else
 #endif
 
-	s->output = s->overlay = s->root;
+	s->output = s->overlay = s->root.id;
 
     showOutputWindow (s);
 }
@@ -1417,10 +1485,13 @@ enterShowDesktopMode (CompScreen *s)
     int		  count = 0;
     CompOption    *st = &d->opt[COMP_DISPLAY_OPTION_HIDE_SKIP_TASKBAR_WINDOWS];
 
+    if (!s->root.substructureRedirect)
+	return;
+
     s->showingDesktopMask = ~(CompWindowTypeDesktopMask |
 			      CompWindowTypeDockMask);
 
-    for (w = s->windows; w; w = w->next)
+    for (w = s->root.windows; w; w = w->next)
     {
 	if ((s->showingDesktopMask & w->wmType) &&
 	    (!(w->state & CompWindowStateSkipTaskbarMask) || st->value.b))
@@ -1443,7 +1514,7 @@ enterShowDesktopMode (CompScreen *s)
 	data = 0;
     }
 
-    XChangeProperty (s->display->display, s->root,
+    XChangeProperty (s->display->display, s->root.id,
 		     s->display->showingDesktopAtom,
 		     XA_CARDINAL, 32, PropModeReplace,
 		     (unsigned char *) &data, 1);
@@ -1456,6 +1527,9 @@ leaveShowDesktopMode (CompScreen *s,
     CompWindow    *w;
     unsigned long data = 0;
 
+    if (!s->root.substructureRedirect)
+	return;
+
     if (window)
     {
 	if (!window->inShowDesktopMode)
@@ -1465,7 +1539,7 @@ leaveShowDesktopMode (CompScreen *s,
 	showWindow (window);
 
 	/* return if some other window is still in show desktop mode */
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	    if (w->inShowDesktopMode)
 		return;
 
@@ -1475,7 +1549,7 @@ leaveShowDesktopMode (CompScreen *s,
     {
 	s->showingDesktopMask = 0;
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	{
 	    if (!w->inShowDesktopMode)
 		continue;
@@ -1489,22 +1563,22 @@ leaveShowDesktopMode (CompScreen *s,
 	focusDefaultWindow (s);
     }
 
-    XChangeProperty (s->display->display, s->root,
+    XChangeProperty (s->display->display, s->root.id,
 		     s->display->showingDesktopAtom,
 		     XA_CARDINAL, 32, PropModeReplace,
 		     (unsigned char *) &data, 1);
 }
 
 static CompWindow *
-walkFirst (CompScreen *s)
+walkFirst (CompWindow *parent)
 {
-    return s->windows;
+    return parent->windows;
 }
 
 static CompWindow *
-walkLast (CompScreen *s)
+walkLast (CompWindow *parent)
 {
-    return s->reverseWindows;
+    return parent->reverseWindows;
 }
 
 static CompWindow *
@@ -1521,6 +1595,7 @@ walkPrev (CompWindow *w)
 
 static void
 initWindowWalker (CompScreen *screen,
+		  CompWindow *window,
 		  CompWalker *walker)
 {
     walker->fini  = NULL;
@@ -1530,6 +1605,42 @@ initWindowWalker (CompScreen *screen,
     walker->prev  = walkPrev;
 }
 
+static Bool
+paintObject (CompWindow		     *w,
+	     const WindowPaintAttrib *attrib,
+	     const CompTransform     *transform,
+	     Region		     region,
+	     unsigned int	     mask)
+{
+    PaintWindowProc paint = w->screen->paintWindow;
+    Bool            status;
+
+    if (w->parent)
+	w->paintWindowStack = w->parent->paintWindowStack;
+    else
+	w->paintWindowStack = paint;
+
+    status = (*w->paintWindowStack) (w, attrib, transform, region, mask);
+
+    w->screen->paintWindow = paint;
+
+    return status;
+}
+
+static void
+initObjectPainter (CompScreen  *screen,
+		   CompPainter *painter)
+{
+    painter->fini        = NULL;
+    painter->paintObject = paintObject;
+}
+
+static FuncPtr
+dummyGetProcAddress (const GLubyte *procName)
+{
+    return NULL;
+}
+
 static void
 freeScreen (CompScreen *s)
 {
@@ -1611,7 +1722,7 @@ addScreen (CompDisplay *display,
     GLfloat		 light0Position[] = { -0.5f, 0.5f, -9.0f, 1.0f };
     CompWindow		 *w;
 
-    s = malloc (sizeof (CompScreen));
+    s = calloc (1, sizeof (CompScreen));
     if (!s)
 	return FALSE;
 
@@ -1652,9 +1763,6 @@ addScreen (CompDisplay *display,
     s->hsize = s->opt[COMP_SCREEN_OPTION_HSIZE].value.i;
     s->vsize = s->opt[COMP_SCREEN_OPTION_VSIZE].value.i;
 
-    s->windowOffsetX = 0;
-    s->windowOffsetY = 0;
-
     s->nDesktop	      = 1;
     s->currentDesktop = 0;
 
@@ -1680,11 +1788,12 @@ addScreen (CompDisplay *display,
 
     s->screenNum = screenNum;
     s->colormap  = DefaultColormap (dpy, screenNum);
-    s->root	 = XRootWindow (dpy, screenNum);
 
     s->mapNum    = 1;
     s->activeNum = 1;
 
+    initRootWindow (s, &s->root);
+
     s->groups = NULL;
 
     s->snContext = sn_monitor_context_new (display->snDisplay,
@@ -1712,9 +1821,6 @@ addScreen (CompDisplay *display,
     s->nOutputDev	= 0;
     s->currentOutputDev = 0;
 
-    s->windows = 0;
-    s->reverseWindows = 0;
-
     s->nextRedraw  = 0;
     s->frameStatus = 0;
     s->timeMult    = 1;
@@ -1781,11 +1887,12 @@ addScreen (CompDisplay *display,
 
     s->outputChangeNotify = outputChangeNotify;
 
-    s->initWindowWalker = initWindowWalker;
+    s->initWindowWalker  = initWindowWalker;
+    s->initObjectPainter = initObjectPainter;
 
-    s->getProcAddress = 0;
+    s->getProcAddress = dummyGetProcAddress;
 
-    if (!XGetWindowAttributes (dpy, s->root, &s->attrib))
+    if (!XGetWindowAttributes (dpy, s->root.id, &s->attrib))
 	return FALSE;
 
     s->workArea.x      = 0;
@@ -1818,7 +1925,7 @@ addScreen (CompDisplay *display,
 	return FALSE;
     }
 
-    bitmap = XCreateBitmapFromData (dpy, s->root, &data, 1, 1);
+    bitmap = XCreateBitmapFromData (dpy, s->root.id, &data, 1, 1);
     if (!bitmap)
     {
 	compLogMessage ("core", CompLogLevelFatal, "Couldn't create bitmap");
